<?php

/*****************************************************************************\
		OPTIONS
\*****************************************************************************/


function suh_get_pagenow( $page = '' ) {
	global $pagenow;
	$result = $pagenow;
	if( empty( $page ) ) {
		$result.= '?page='.$_GET['page'];
	} else {
		$result.= '?page='.$page;
	}
	return $result;
}


add_action( 'network_admin_menu','suh_network_admin_menu' );

function suh_network_admin_menu() {
	add_submenu_page( 'settings.php', __( 'Superadmin helper settings' /*'Nastavení Superadmin helper'*/, SUH_TEXTDOMAIN ), 
		__( 'Superadmin helper', SUH_TEXTDOMAIN ), 'manage_network_options', 'suh-options', 'suh_options_page' );
}


add_action( 'admin_menu','suh_admin_menu' );

function suh_admin_menu() {
	if( is_multisite() ) {
		return;
	}
	add_submenu_page( 'options-general.php', __( 'Superadmin helper settings', SUH_TEXTDOMAIN ), 
		__( 'Superadmin helper', SUH_TEXTDOMAIN ), 'manage_options',  'suh-options', 'suh_options_page' );
}


function suh_options_page() {
	if( isset($_REQUEST['action']) ) {
        $action = $_REQUEST['action'];
    } else {
        $action = 'default';
    }
    
    switch( $action ) {
    case 'update-options':
    	/*update_site_option( 'suh_permban_active', ( isset( $_POST['suh_permban_active'] ) ? 'true' : 'false' ) );
    	update_site_option( 'suh_banned_message', $_POST['suh_banned_message'] );*/
    	suh_update_settings( $_POST['settings'] );
    	suh_nag( __( 'Settings saved', SUH_TEXTDOMAIN ) );
    	suh_options_page_default();
    	break;
    case 'wls-register':
    	$ok1 = wls_register( 'suh-log', __( 'Basic information about events in multisite network.', SUH_TEXTDOMAIN ) );
    	$ok2 = wls_register( 'suh-mail', __( 'List of e-mails sent by WordPress', SUH_TEXTDOMAIN ) );
    	$ok = $ok1 && $ok2;
    	if( $ok ) {
    		$info = __( 'Superadmin Helper was successfully registered with WLS.', SUH_TEXTDOMAIN );
    		suh_nag( $info );
    		suh_log( $info, 2 );
    	} else {
    		$info = __( 'Error while trying to register Superadmin Helper with WLS.', SUH_TEXTDOMAIN );;
    		suh_nagerr( $info );
    		suh_log( $info, WLS_ERROR );
    	}
    	suh_options_page_default();
    	break;
    case 'wls-unregister':
    	$ok1 = wls_unregister( 'suh-log' );
    	$ok2 = wls_unregister( 'suh-mail' );
    	$ok = $ok1 && $ok2;
    	if( $ok ) {
    		$info = __( 'Superadmin Helper successfully unregistered from WLS, log entries deleted.', SUH_TEXTDOMAIN );
    		suh_nag( $info );
    		suh_log( $info, 2 );
    	} else {
    		$info = __( 'Error while trying to unregister Superadmin Helper from WLS', SUH_TEXTDOMAIN );
    		suh_nagerr( $info );
    		suh_log( $info, WLS_ERROR );
    	}
    	suh_options_page_default();
    	break;
    default:
    	suh_options_page_default();
    	break;
    }
}


function suh_options_page_default() {
	extract( suh_get_settings() );
	?>
	<div id="wrap">
		<h2><?php _e( 'Superadmin Helper options', SUH_TEXTDOMAIN ); ?></h2>
		<?php
			if( !$hide_donation_button ) {
				?>
				<h3><?php _e( 'Please consider a donation', SUH_TEXTDOMAIN ); ?></h3>
				<p>
					<?php _e( 'I spend quite a lot of my precious time working on opensource WordPress plugins. If you find this one useful, please consider helping me develop it further. Even the smallest amount of money you are willing to spend will be welcome.', SUH_TEXTDOMAIN ); ?>
					<form action="https://www.paypal.com/cgi-bin/webscr" method="post"><input type="hidden" name="cmd" value="_s-xclick">
						<input type="hidden" name="hosted_button_id" value="39WB3KGYFB3NA">
						<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!" style="border:none;" >
						<img style="display:none;" alt="" border="0" src="https://www.paypalobjects.com/en_US/i/scr/pixel.gif" width="1" height="1">
					</form>
				</p>
				<?php
			}
		?>
		<?php
			if( defined( 'WLS' ) ) {
				?>			 
				<h3><?php _e( 'Registration with WLS', SUH_TEXTDOMAIN ); ?></h3>
		    	<p><?php _e( 'Wordpress Logging Service was detected.', SUH_TEXTDOMAIN ); ?></p>
	    		<?php
	    			if( !wls_is_registered( 'suh-log' ) or !wls_is_registered( 'suh-mail' ) ) {
	    				?>
						<form method="post"">
							<input type="hidden" name="action" value="wls-register" />
							<p class="submit">
								<input type="submit" value="<?php _e( 'Register with WLS', SUH_TEXTDOMAIN ); ?>" />    
							</p> 
						</form>
						<?php
					} else {
						?>
						<form method="post">
							<input type="hidden" name="action" value="wls-unregister" />
							<p class="submit">
								<input type="submit" style="color:red;" value="<?php _e( 'Unregister from WLS and delete log entries', SUH_TEXTDOMAIN ); ?>" />    
							</p> 
						</form>
						<?php
					}
				?>
				<?php
        	} 
        ?>
        <h3><?php _e( 'Permban', SUH_TEXTDOMAIN ); ?></h3>
        <form method="post">
            <input type="hidden" name="action" value="update-options" />
            <input type="hidden" name="settings[db_version]" value="<?php echo $db_version; ?>" />
            <input type="hidden" name="settings[permban_ready]" value="<?php echo $permban_ready; ?>" />
            <table class="form-table">
                <tr valign="top">
                	<th>
                		<label for="settings[is_permban_active]">
                			<?php _e( 'Activate IP permban when someone tries to login as "admin"', SUH_TEXTDOMAIN ); ?>
	                	</label>
	                </th>
                	<td>
                		<input type="checkbox" name="settings[is_permban_active]" 
                			<?php if( $is_permban_active ) echo 'checked="checked"'; ?>" 
                		/>
                	</td>
                </tr>
                <tr valign="top">
                	<th>
                		<label for="settings[forbidden_logins]">
                			<?php _e( 'Forbiden logins', SUH_TEXTDOMAIN ); ?>
                		</label>
                	</th>
                	<td>
                		<input type="text" name="settings[forbidden_logins]" value="<?php echo $forbidden_logins; ?>" />
                	</td>
                	<td>
                		<small><?php printf( __( 'If anyone tries to login with this account names, their IP will be banned. You can separate multiple logins by %s.', SUH_TEXTDOMAIN ), '<code>,</code>' ); ?></small>
                	</td>
                </tr>
                <tr valign="top">
                	<th>
                		<label for="settings[banned_message]">
                			<?php _e( 'Message to be shown to blocked viewers', SUH_TEXTDOMAIN ); ?>
                		</label>
                	</th>
                	<td>
                		<textarea name="settings[banned_message]" cols="60" rows="15" style="font-family: monospace;"><?php
                			echo stripslashes( $banned_message ); 
                		?></textarea>
                	</td>
                </tr>
           </table>
           <h3><?php _e( 'Event logging', SUH_TEXTDOMAIN ); ?></h3>
           <table class="form-table">
                <tr valign="top">
                	<th>
                		<label>Attempt to access site from banned IP</label><br />
                	</th>
                	<td>
                		<input type="checkbox" name="settings[log_banned_attempt]" 
                			<?php if( $log_banned_attempt ) echo 'checked="checked"'; ?>
                		/>
                	</td>
                	<td><small><?php _e( 'If checked, every attempt to access this site from a banned IP will be logged.', SUH_TEXTDOMAIN ); ?></small></td>
                </tr>
                <tr valign="top">
                	<th>
                		<label><code>wp_mail</code></label><br />
                	</th>
                	<td>
                		<input type="checkbox" name="settings[log_wp_mail]" 
                			<?php if( $log_wp_mail ) echo 'checked="checked"'; ?>
                		/>
                	</td>
                	<td><small><?php printf( __( 'If checked, every e-mail send by WordPress will be logged in %s category.', SUH_TEXTDOMAIN ), '<code>suh-mail</code>' ); ?></small></td>
                </tr>
                <tr valign="top">
                	<th>
                		<label><code>wp_login</code></label><br />
                	</th>
                	<td>
                		<input type="checkbox" name="settings[log_wp_login]" 
                			<?php if( $log_wp_login ) echo 'checked="checked"'; ?>
                		/>
                	</td>
                	<td><small><?php _e( 'Successful logins', SUH_TEXTDOMAIN ); ?></small></td>
                </tr>
                <tr valign="top">
                	<th>
                		<label><code>wp_logout</code></label><br />
                	</th>
                	<td>
                		<input type="checkbox" name="settings[log_wp_logout]" 
                			<?php if( $log_wp_logout ) echo 'checked="checked"'; ?>
                		/>
                	</td>
                </tr>
                <tr valign="top">
                	<th>
                		<label><code>blog_redirect_404</code></label><br />
                	</th>
                	<td>
                		<input type="checkbox" name="settings[log_blog_redirect_404]" 
                			<?php if( $log_blog_redirect_404 ) echo 'checked="checked"'; ?>
                		/>
                	</td>
                	<td><small><?php _e( 'Works if NOBLOGREDIRECT is defined.', SUH_TEXTDOMAIN ); ?></small></td>
                </tr>
			</table>
			<h3><?php _e( 'Other settings', SUH_TEXTDOMAIN ); ?></h3>
           	<table class="form-table">
                <tr valign="top">
                	<th>
                		<label><?php _e( 'Hide donation button', SUH_TEXTDOMAIN ); ?></label><br />
                	</th>
                	<td>
                		<input type="checkbox" name="settings[hide_donation_button]" 
                			<?php if( $hide_donation_button ) echo 'checked="checked"'; ?>
                		/>
                	</td>
                	<td><small><?php _e( 'If you don\'t want to be bothered again...', SUH_TEXTDOMAIN ); ?></small></td>
                </tr>
			</table>
			<p class="submit">
	            <input type="submit" class="button-primary" value="<?php _e( 'Save', SUH_TEXTDOMAIN ); ?>" />    
	        </p>
		</form>
	</div>
	<?php
}


define( 'SUH_SETTINGS', 'suh_settings' );


function suh_get_settings() {
	$defaults = array(
		'is_permban_active' => false,
		'forbidden_logins' => 'admin',
		'banned_message' => '',
		'hide_donation_button' => false,
		'permban_ready' => false,
		'db_version' => 1,
		'log_blog_redirect_404' => true,
		'log_wp_mail' => true,
		'log_wp_login' => true,
		'log_wp_logout' => true
	);
	
	$settings = get_site_option( SUH_SETTINGS, array() );
	
	return wp_parse_args( $settings, $defaults );
}


function suh_get_setting( $setting ) {
	$settings = suh_get_settings();
	return $settings[$setting];
}


function suh_update_settings( $settings ) {
	update_site_option( SUH_SETTINGS, $settings );
}



?>
